/* javascript.c -- functions to grok javascript */
#include "javascript.h"
#include "server.h"

#define NL "\r\n"

char *javascript_code_prefix1 =
"<SCRIPT LANGUAGE=\"JavaScript\">" NL
"<!-- Begin to hide script contents from old browsers" NL
"java.lang.System.out.println('Secure Proxy by C. Scott Ananian');" NL
"// utility functions" NL
"function " JS_PREFIX "isWS(c) { return (c==' '||c=='\\t'||c=='\\r'||c=='\\n'); }" NL
"function " JS_PREFIX "findend(str, ind) {" NL
"  if (str.charAt(ind)=='\"') return str.indexOf('\"', ind+1);" NL
"  if (str.charAt(ind)==\"\'\") return str.indexOf(\"\'\", ind+1);" NL
"  while(ind<str.length && !" JS_PREFIX "isWS(str.charAt(ind)) "
         "&& str.charAt(ind)!='\\x3C' && str.charAt(ind)!='\\x3E' "
         ")" NL
"    ind++;" NL
"  return (ind<str.length)?ind:-1;" NL
"}" NL
"function " JS_PREFIX "escape(str) {" NL
"  // stop at ? or # in URL" NL
"  var stpQ=str.indexOf('?'), stpH=str.indexOf('#');" NL
"  var stp = (stpQ>=0 && (stpH<0 || stpQ<stpH))?stpQ:stpH;" NL
"  var tail = '';" NL
"  if (stp>=0) { " NL
"    tail=str.substring(stp, str.length); str=str.substring(0,stp);" NL
"  }" NL
"  var rs=escape(str);" NL
"  while(rs.indexOf('%')>=0)" NL
"    rs = rs.substring(0, rs.indexOf('%')) + ',' + " NL
"         rs.substring(rs.indexOf('%')+1, rs.length);" NL
"  return rs + tail;" NL
"}" NL
"function " JS_PREFIX "urlencode(str) {" NL
#ifdef VERBOSE_DEBUG
"  java.lang.System.out.println('GROKKING: '+str);" NL
#endif
"  if (str.indexOf('http:')==0) {" NL
"    return '" ENCODE_PREFIX "'+" JS_PREFIX "escape(str);" NL
"  } else if (str.indexOf('/')==0) {" NL
"    return '" ENCODE_PREFIX "'+" JS_PREFIX "escape('http://";
char *javascript_code_prefix2 =
"'+str);" NL
"  } else return str;" NL
"}" NL
"function " JS_PREFIX "Dump(str) {" NL
"  var startpoint = 0;" NL
" while (true) {" NL
"  var findSRC = str.toUpperCase().indexOf('SRC', startpoint);" NL
"  var findHREF= str.toUpperCase().indexOf('HREF', startpoint);" NL
"  var find=-1;" NL
"  if ((findSRC>=0) &&" NL
"      (findHREF<0 || (findHREF>=0 && findSRC<findHREF)))" NL
"      find = findSRC+3;" NL
"  if ((findHREF>=0) &&" NL
"      (findSRC<0 || (findSRC>=0 && findHREF<findSRC)))" NL
"      find = findHREF+4;" NL
"  if (find<0) break; // no more SRC or HREF strings." NL
"  while (" JS_PREFIX "isWS(str.charAt(find))) find++;" NL
"  if (str.charAt(find++)!='=') { startpoint=find; continue; }" NL
"  while (" JS_PREFIX "isWS(str.charAt(find))) find++;" NL
"  var attrend = " JS_PREFIX "findend(str, find);" NL
"  if (attrend<find) break; // no more strings" NL
"  if (str.charAt(find)=='\"' || str.charAt(find)==\"\'\")" NL
"    find++;" NL
"  var enddist = str.length-attrend;" NL
"  str = str.substring(0, find) + " NL
"        " JS_PREFIX "urlencode(str.substring(find, attrend)) + " NL
"        str.substring(attrend, str.length);" NL
"  startpoint = str.length-enddist;" NL
" }" NL
"  document." JS_PREFIX "write(str);" NL
"}" NL
JS_PREFIX "buffer = '';" NL
NL
"// save original versions of methods." NL
"document." JS_PREFIX "write = document.write;" NL
"window." JS_PREFIX "open = window.open;" NL
"location." JS_PREFIX "replace = location.replace;" NL
"location." JS_PREFIX "assign  = location.assign;" NL
"// define altered versions" NL
"function " JS_PREFIX "Xwriteln(str) {"
" " JS_PREFIX "Xwrite(str+\"\\n\"); }" NL
"function " JS_PREFIX "Xwrite(str) {" NL
"  " JS_PREFIX "buffer += str;" NL
"}" NL
"function " JS_PREFIX "Xopen(url, loc) {" NL
"  window." JS_PREFIX "open(" JS_PREFIX "urlencode(url),loc);" NL
"}" NL
"function " JS_PREFIX "Xreplace(url) {" NL
"  window.location." JS_PREFIX "replace(" JS_PREFIX "urlencode(url));" NL
"}" NL
"function " JS_PREFIX "Xassign(url) {" NL
"  window.location." JS_PREFIX "assign(" JS_PREFIX "urlencode(url));" NL
"}" NL
"// use the altered versions by default." NL
"document.write = " JS_PREFIX "Xwrite;" NL
"document.writeln = " JS_PREFIX "Xwriteln;" NL
"window.open = " JS_PREFIX "Xopen;" NL
"if (location.replace!=null) location.replace = " JS_PREFIX "Xreplace;" NL
"location.assign = "JS_PREFIX "Xassign;" NL
"//End the hiding here. -->" NL
"</SCRIPT>";

char * javascript_code_suffix =
"<SCRIPT LANGUAGE=\"JavaScript\">" NL
"<!-- Begin to hide script contents from old browsers" NL
JS_PREFIX "Dump(" JS_PREFIX "buffer);" NL
JS_PREFIX "buffer = '';" NL
"//End the hiding here. -->" NL
"</SCRIPT>";
