/* linereader.h */
#ifndef INC_LINEREADER
#define INC_LINEREADER

typedef int (*LR_readfunc_t) (void *where, void *buf, int size);

typedef struct {
  /* source */
  LR_readfunc_t readfunc;
  void *where;
  /* buffer */
  char *buf;
  int size;
  int cnt;
  int eof;
} LR_input_t;

/* initialize a new buffer, preloading with str */
LR_input_t LR_init(LR_readfunc_t rf, void *where, char *str);

/* read a line from in, and return it.  Else NULL for eof */
char *LR_readline(LR_input_t * in);

/* return a pointer to a buffer with the next exactly 'length' characters
   from in. */
void *LR_rawread(LR_input_t * in, int * length);

/* frees memory associated with an LR_input_t */
void LR_free(LR_input_t * in);

#endif
