/* writer.c --- write fully. */
#include <openssl/ssl.h>
#include <unistd.h>
#include "writer.h"

ssize_t write_fully(int fd, const void *buf, size_t count) {
  size_t written=0;
  while (written < count) {
    int err = write(fd, buf+written, count-written);
    if (err <= 0) return (written>0)?written:err;
    else written+=err;
  }
  return written;
}

int SSL_write_fully(SSL *ssl, const char *buf, int count) {
  int written=0;
  while (written < count) {
    int err = SSL_write(ssl, buf+written, count-written);
    if (err <= 0) return (written>0)?written:err;
    else written+=err;
  }
  return written;
}
